function name:
pow(x,y)

exceptional values:
fx = 0.0;
fy = 0.0;
fxx = 0.0;
fxy = 0.0;
fyy = 0.0;

template:
{
##  /* Open brace must be first */
#ifdef FVAL
     z = pow(x,y);
#endif
#finish FVAL
     if ( x != 0.0 ) { /*pow*/
          if ( x < 0.0 ) {
##             /* Only want to set: fy, fxy, fyy */
               EXCEPTION_HANDLER();
## Begin duplicated section A.
               z = pow(x,(y-2.0));
               fxx = y * (y-1.0) * z;
               z = z * x;
               fx = y * z;
## End duplicated section A.
               z = z * x;
         }
         else {
## Begin duplicated section A.
               z = pow(x,(y-2.0));
               fxx = y * (y-1.0) * z;
               z = z * x;
               fx = y * z;
## End duplicated section A.
               fy = log (x);
               fxy = z * (y * fy + 1.0);
               z = z * x;
               fyy = ( fy * fy ) * z;
               fy = fy * z;
         }
     }
     else {
          z = pow(x,y);
          EXCEPTION_HANDLER();
          if ( y >= 1 ) {
               fx = 0.0;
#ifdef SECOND
               if ( y >= 2 ) {
                    fxx = 0.0;
               }
#endif /* SECOND */
          }
##
##       Read the above as:
###ifdef FIRST
##         if ( y .lt. 1.0 ) then
##            call EXCEPTION_HANDLER  (sets fx, fy)
##         else
##            fx = 0.0
##            call EXCEPTION_HANDLER  (sets     fy)
##         endif
###elif SECOND
##         if ( y .lt. 1.0 ) then
##            call EXCEPTION_HANDLER (sets fx, fy,fxx,fxy,fyy for sure) 
##         else if ( y .lt. 2.0 ) then
##            fx = 0.0
##            call EXCEPTION_HANDLER (sets     fy,fxx,fxy,fyy only)
##         else 
##            fx = 0.0
##            fxx = 0.0
##            call EXCEPTION_HANDLER (sets     fy,   ,fxy,fyy only)
##         endif
###endif /* SECOND */
##
      }
}
