function ex12(np,opt)
%
%   ex12(np) 
%  Runs ex12.c with the AMS turned on
%
% Run with option -on_error_attach_debugger to debug
%
%  Requires the Matlab mex routines in ${PETSC_DIR}/src/sys/src/viewer/impls/socket/matlab,
% ${AMS_DIR}/matlab and ${AMS_DIR}/matlab/petsc. To make the PETSc files cd to 
% ${PETSC_DIR} and run make BOPT=g matlabcodes
% then make sure that ${PETSC_DIR}/src/sys/src/viewer/impls/socket/matlab is in your Matlab PATH.
%
if (nargin < 1)
  np = 1;
end
if (nargin < 2) 
  opt = ' ';
end
count = 30;
err = launch(['ex12 -count ' int2str(count) ' -ams_publish_objects -ams_publish_stack ' opt '> /dev/null'] ,np);
if (err ~= 0) then 
  return;
end
pause(18);
x = ams_view
exit
