
#line 770 "ad_adj.w"
#include <stdlib.h>

#line 43 "ad_adj.w"
#define FLOAT 	float


#define AD_FUNC_ENTER(x) \
    ad_adj_enter()

#define AD_MALLOC(x) \
    ad_adj_malloc(x)

#define AD_CALLOC(x,y) \
    ad_adj_calloc(x,y)

#define AD_REALLOC(x,y) \
    ad_adj_realloc(x,y)

#define AD_FREE(x) \
    ad_adj_free(x)

#define ad_AD_SetIndep(x)  AD_SetIndep(x)
#define ad_AD_SetIndepDone()  AD_SetIndepDone()

#define AD_SetIndep(x)

#define AD_SetIndepDone()

#define ad_AD_SetSeed(x, y)  AD_SetSeed(x, y)

#define ad_AD_TapeOn()  AD_TapeOn()
#define AD_TapeOn()  ad_adj_tape_on()

#define ad_AD_TapeOff()  AD_TapeOff()
#define AD_TapeOff()  ad_adj_tape_off()

#define AD_SetSeed(x, y) \
    ad_adj_set_seed(DERIV_adj(x), y)

#define ad_AD_ExtractAdj(x, y)  AD_ExtractAdj(x, y)

#define AD_ExtractAdj(x, y) \
    ad_adj_extract(DERIV_adj(x), &y)

#define AD_VAR_INIT(x) \
    ad_adj_var_init(&x, sizeof(x))

#define ad_AD_AdjointInit() \
    ad_adj_init()

#define ad_AD_AdjointFinal() \
    ad_adj_final()

#define ad_AD_Reverse() \
    ad_adj_reverse()


void ad_adj_set_seed(double*, double);
void ad_adj_extract(double*, double*);
void ad_adj_var_init(void *x, int size);
void ad_adj_tape_on();
void ad_adj_tape_off();




#line 196 "ad_adj.w"
void ad_tape_open_op();
void ad_tape_start_op();
void ad_tape_rev_start_op();
void ad_tape_put_op(int op, int count);
void ad_tape_stop_op();
int ad_tape_get_op(int* count);



#line 269 "ad_adj.w"
void ad_tape_open_addr();
void ad_tape_start_addr();
void ad_tape_rev_start_addr();
void ad_tape_put_addr(double* pa);
void ad_tape_stop_addr();
double* ad_tape_get_addr();



#line 423 "ad_adj.w"
void ad_adj_axpy_0(double* dz);
void ad_adj_axpy_copy(double* dz, double* dx);
void ad_adj_axpy_1(double* dz, double a, double* da);
void ad_adj_axpy_n(int arity, double* dz, ...);



#line 504 "ad_adj.w"
void ad_adj_reverse();



#line 589 "ad_adj.w"
void ad_adj_enter();



#line 616 "ad_adj.w"
void* ad_adj_malloc(size_t size);
void* ad_adj_realloc(void* ptr, size_t size);
void* ad_adj_calloc(size_t size, size_t elsize);
void ad_adj_free(void* p);



#line 686 "ad_adj.w"
void nullMemory();



#line 710 "ad_adj.w"
void ad_adj_init();
void ad_adj_final();





